## org.freedesktop.ModemManager1.Bearer

org.freedesktop.ModemManager1.Bearer — The ModemManager Bearer interface.

## Methods

    Connect    ();
    Disconnect ();

## Properties

    Interface             readable   s
    Connected             readable   b
    ConnectionError       readable   (ss)
    DisconnectRequest     readable   b
    Suspended             readable   b
    Multiplexed           readable   b
    Ip4Config             readable   a{sv}
    Ip6Config             readable   a{sv}
    Stats                 readable   a{sv}
    ReloadStatsSupported  readable   b
    IpTimeout             readable   u
    BearerType            readable   u
    ProfileId             readable   i
    Properties            readable   a{sv}

## Description

This interface provides access to specific actions that may be performed on available bearers.

## Method Details

### The `Connect()` method

    Connect ();

Requests activation of a packet data connection with the network using this bearer's properties. Upon successful activation, the modem can send and receive packet data and, depending on the addressing capability of the modem, a connection manager may need to start PPP, perform DHCP, or assign the IP address returned by the modem to the data interface. Upon successful return, the "Ip4Config" and/or "Ip6Config" properties become valid and may contain IP configuration information for the data interface associated with this bearer.

Since: 1.0

### The `Disconnect()` method

    Disconnect ();

Disconnect and deactivate this packet data connection.

Any ongoing data session will be terminated and IP addresses become invalid when this method is called.

Since: 1.0

## Property Details

### The "Interface" property

    Interface  readable   s

The operating system name for the network data interface that provides packet data using this bearer.

Connection managers must configure this interface depending on the IP `"method"` given by the "Ip4Config" or "Ip6Config" properties set by bearer activation.

If MM_BEARER_IP_METHOD_STATIC or MM_BEARER_IP_METHOD_DHCP methods are given, the interface will be an ethernet-style interface suitable for DHCP or setting static IP configuration on, while if the MM_BEARER_IP_METHOD_PPP method is given, the interface will be a serial TTY which must then have PPP run over it.

Since: 1.0

### The "Connected" property

    Connected  readable   b

Indicates whether or not the bearer is connected and thus whether packet data communication using this bearer is possible.

Since: 1.0

### The "ConnectionError" property

    ConnectionError  readable   (ss)

Provides additional information specifying the reason why the modem is not connected (either due to a failed connection attempt, or due to a a network initiated disconnection).

The value is composed of two strings: the registered DBus error name, and an optional error message.

Since: 1.18

### The "DisconnectRequest" property

    DisconnectRequest  readable   b

Indicates that the bearer is no longer useable and the connection manager should terminate it as soon as possible.

Since: 1.26

### The "Suspended" property

    Suspended  readable   b

In some devices, packet data service will be suspended while the device is handling other communication, like a voice call. If packet data service is suspended (but not deactivated) this property will be `TRUE`.

Since: 1.0

### The "Multiplexed" property

    Multiplexed  readable   b

This property will be `TRUE` if the bearer is connected through a multiplexed network link.

Since: 1.18

### The "Ip4Config" property

    Ip4Config  readable   a{sv}

If the bearer was configured for IPv4 addressing, upon activation this property contains the addressing details for assignment to the data interface.

Mandatory items include:

`"method"` | A MMBearerIpMethod, given as an unsigned integer value (signature `"u"`).

If the bearer specifies configuration via PPP or DHCP, only the `"method"` item is guaranteed to be present.

Additional items which are only applicable when using the MM_BEARER_IP_METHOD_STATIC method are:

`"address"` | IP address, given as a string value (signature `"s"`).
`"prefix"` | Numeric CIDR network prefix (ie, 24, 32, etc), given as an unsigned integer value (signature `"u"`).
`"dns1"` | IP address of the first DNS server, given as a string value (signature `"s"`).
`"dns2"` | IP address of the second DNS server, given as a string value (signature `"s"`).
`"dns3"` | IP address of the third DNS server, given as a string value (signature `"s"`).
`"gateway"` | IP address of the default gateway, given as a string value (signature `"s"`).

This property may also include the following items when such information is available:

`"mtu"` | Maximum transmission unit (MTU), given as an unsigned integer value (signature `"u"`).

Since: 1.0

### The "Ip6Config" property

    Ip6Config  readable   a{sv}

If the bearer was configured for IPv6 addressing, upon activation this property contains the addressing details for assignment to the data interface.

Mandatory items include:

`"method"` | A MMBearerIpMethod, given as an unsigned integer value (signature `"u"`).

If the bearer specifies configuration via PPP or DHCP, often only the `"method"` item will be present. IPv6 SLAAC should be used to retrieve correct addressing and DNS information via Router Advertisements and DHCPv6. In some cases an IPv6 Link-Local `"address"` item will be present, which should be assigned to the data port before performing SLAAC, as the mobile network may expect SLAAC setup to use this address.

Additional items which are usually only applicable when using the MM_BEARER_IP_METHOD_STATIC method are:

`"address"` | IP address, given as a string value (signature `"s"`).
`"prefix"` | Numeric CIDR network prefix (ie, 24, 32, etc), given as an unsigned integer value (signature `"u"`).
`"dns1"` | IP address of the first DNS server, given as a string value (signature `"s"`).
`"dns2"` | IP address of the second DNS server, given as a string value (signature `"s"`).
`"dns3"` | IP address of the third DNS server, given as a string value (signature `"s"`).
`"gateway"` | IP address of the default gateway, given as a string value (signature `"s"`).

This property may also include the following items when such information is available:

`"mtu"` | Maximum transmission unit (MTU), given as an unsigned integer value (signature `"u"`). Since 1.4.

Since: 1.0

### The "Stats" property

    Stats  readable   a{sv}

If the modem supports it, this property will show statistics associated to the bearer.

There are two main different statistic types reported: either applicable to the ongoing connection, or otherwise compiled for all connections that have been done on this bearer object.

When the connection is disconnected automatically or explicitly by the user, the values applicable to the ongoing connection will show the last values cached.

The following items may appear in the list of statistics:

`"rx-bytes"` | Number of bytes received without error in the ongoing connection, given as an unsigned 64-bit integer value (signature `"t"`).
`"tx-bytes"` | Number of bytes transmitted without error in the ongoing connection, given as an unsigned 64-bit integer value (signature `"t"`).
`"start-date"` | Timestamp indicating when the ongoing connection started, given as an unsigned 64-bit integer value representing seconds since the epoch (signature `"t"`). Since 1.20.
`"duration"` | Duration of the ongoing connection, in seconds, given as an unsigned integer value (signature `"u"`).
`"attempts"` | Total number of connection attempts done with this bearer, given as an unsigned integer value (signature `"u"`). Since 1.14.
`"failed-attempts"` | Number of failed connection attempts done with this bearer, given as an unsigned integer value (signature `"u"`). Since 1.14.
`"total-rx-bytes"` | Total number of bytes received without error in all the successful connection establishments, given as an unsigned 64-bit integer value (signature `"t"`). Since 1.14.
`"total-tx-bytes"` | Total number of bytes transmitted without error in all the successful connection establishments, given as an unsigned 64-bit integer value (signature `"t"`). Since 1.14.
`"total-duration"` | Total duration of all the successful connection establishments, in seconds, given as an unsigned integer value (signature `"u"`). Since 1.14.
`"uplink-speed"` | Uplink bit rate negotiated with network, in bits per second, given as an unsigned 64-bit integer value (signature `"t"`). Since 1.20.
`"downlink-speed"` | Downlink bit rate negotiated with network, in bits per second, given as an unsigned 64-bit integer value (signature `"t"`). Since 1.20.

Since: 1.6

### The "ReloadStatsSupported" property

    ReloadStatsSupported  readable   b

Indicates whether reloading ongoing statistics is supported or not.

This property applies exclusively to the statistics that are queried from the modem periodically; i.e. "rx-bytes", "tx-bytes", "uplink-speed" and "downlink-speed".

The property is initialized to a fixed value as soon as the first connection attempt has successfully finished. Reading this value before the first successful connection attempt will always report `FALSE`.

Since: 1.20

### The "IpTimeout" property

    IpTimeout  readable   u

Maximum time to wait for a successful IP establishment, when PPP is used.

Since: 1.0

### The "BearerType" property

    BearerType  readable   u

A MMBearerType

Since: 1.10

### The "ProfileId" property

    ProfileId  readable   i

The profile ID this bearer object is associated with, only applicable if the modem supports profile management operations, and if the bearer is connected.

If the bearer is disconnected, or if profile management operations are not supported, -1 will be reported.

Since: 1.18

### The "Properties" property

    Properties  readable   a{sv}

List of settings used to create the bearer.

Bearers may be implicitly created (e.g. the default initial EPS bearer created during the network registration process in 4G and 5G networks) or explicitly created by the user (e.g. via the `CreateBearer()` or `Connect()` calls).

The following settings apply to 3GPP (GSM/UMTS/LTE/5GNR) devices:

`"apn"` | The Access Point Name to use in the connection, given as a string value (signature `"s"`). For 5G NGC, this field contains the Data Network Name (DNN).
`"ip-type"` | The IP addressing type to use, given as a MMBearerIpFamily value (signature `"u"`).
`"apn-type"` | The purposes of the specified APN, given as a MMBearerApnType value (signature `"u"`).
`"allowed-auth"` | The authentication method to use, given as a MMBearerAllowedAuth value (signature `"u"`).
`"user"` | The user name (if any) required by the network, given as a string value (signature `"s"`).
`"password"` | The password (if any) required by the network, given as a string value (signature `"s"`).
`"access-type-preference"` | Access type preference for 5G devices, given as a MMBearerAccessTypePreference value (signature `"u"`. Since 1.20.
`"roaming-allowance"` | Roaming allowance, given as a MMBearerRoamingAllowance value (signature `"u"`. If supported, this setting should be used instead of 'allow-roaming'. Since 1.20.

`"profile-id"`

The ID of the 3GPP profile to connect to (signature `"i"`), as given in the profile list. In this case, if additional profile settings are given in the properties and they already exist in the profile (e.g. `"apn"`), the new settings will be explicitly ignored; the settings stored in the profile itself always take preference. The value -1 is used to indicate an invalid or uninitialized profile id. Since 1.18.

`"profile-name"` | The name of the profile, given as a string value (signature `"s"`). This value has no effect on the connection, but can be used by the host to identify the profiles. This setting only applies on profile management operations, it should not be used as part of the settings of an explicit connection attempt. Since 1.20.

`"profile-enabled"`

Boolean flag specifying whether the profile is enabled or disabled, given as a boolean value (signature `"b"`). Profiles that are disabled will not be automatically connected by the modem in any way, and attempting to connect them explicitly will fail. This setting only applies on profile management operations, it should not be used as part of the settings of an explicit connection attempt. Since 1.20.

`"profile-source"` | A MMBearerProfileSource value (signature `"u"`, specifying how the profile was created. This setting only applies on profile management operations, it should not be used as part of the settings of an explicit connection attempt. Since 1.20.

The following settings apply to 3GPP2 (CDMA/EVDO) devices:

`"rm-protocol"` | The protocol of the Rm interface, given as a MMModemCdmaRmProtocol value (signature `"u"`).

The following settings apply to all devices types:

`"allow-roaming"` | Specifies whether the connections are allowed even when the device is registered in a roaming (partner or non-partner) network, given as a boolean value (signature `"b"`). This setting applies only to the connection attempts started via Simple.Connect() or Bearer.Connect(). This is a volatile setting, never stored in the device.
`"multiplex"` | The multiplex support requested by the user, given as a MMBearerMultiplexSupport value (signature `"u"`). Since 1.18.

The following settings are no longer supported, but they are kept on the interface for compatibility purposes:

`"number"` | Number to dial for the data connection, given as a string value (signature `"s"`). Deprecated since version 1.10.0.

Since: 1.0